<?php
// Wires-X Dashboard
// very simple dashboard for Yaesu Wires-X systems
// by ik5xmk David
// for radioamateur purpose only
// March, 2019, 24

// This PHP script wants a server WEB and PHP interpreter working on the PC with Yaesu software

// CONFIG SECTION
//
// enter full log file name with path
$logFileName = "C:\Users\utente2018\Documents\WIRESXA\AccHistory\WiresAccess.log";
//
// enter full web server public www directory (we are in Windows, see your installation)
$wwwServerDir = "c:\wamp\www";
//
// enter separator char for fields in rows in log file (like Yaesu format wants)
$sepChar = "%";
//
// disable error warning
ini_set('display_errors','off');
//
// the title of our page, customize it as you like
$pageTitle = "Wires-X Server Dashboard [ #41898 TUSCANY MULTIP GRF ]";
//
// Serial of node/interlink to show on dashboard like LINK/GATEWAY
// this is usefull to locate stations passing on, but not linked dicrectly
$nodeSerial = "E0C4W";

$i = 0; // rows/records
// read log file and capture rows and fields like records
if ($file = fopen($logFileName, "r")) {
    while(!feof($file)) {
        // read single line
        $line = fgets($file);
        // create fields from record/line
        $myRecord = explode($sepChar, $line);
        // make my array to work with, i am interested in some fields only
        $myLog[$i] = array("Callsign" => $myRecord[0], "Serial" => $myRecord[1], "TX" => $myRecord[3], "Port" => $myRecord[4], "Location" => $myRecord[6]);
        ++$i;
    }
    fclose($file);
}

// sort array by "TX time" field
$sortArray = array();
foreach($myLog as $myTX){
    foreach($myTX as $key=>$value){
        if(!isset($sortArray[$key])){
            $sortArray[$key] = array();
        }
        $sortArray[$key][] = $value;
    }
}
$orderby = "TX"; // key to sort by
array_multisort($sortArray[$orderby],SORT_DESC,$myLog); // make the myLog array sorted!

// now draw the log like html page
echo "<html><head><title>".$pageTitle."</title>";

// simple beatiful style :-)
?>
<style>
#users {
  font-family: "Trebuchet MS", Arial, Helvetica, sans-serif;
  border-collapse: collapse;
  width: 100%;
}
#users td, #users th {
  border: 1px solid #ddd;
  padding: 8px;
}
#users tr:nth-child(even){background-color: #f2f2f2;}
#users tr:hover {background-color: #ddd;}
#users th {
  padding-top: 12px;
  padding-bottom: 12px;
  text-align: left;
  background-color: #4CAF50;
  color: white;
}
a:link {
  text-decoration: none;
}
a:visited {
  text-decoration: none;
}
a:hover {
  text-decoration: underline;
}
a:active {
  text-decoration: underline;
}
</style>
<?php

echo "<meta http-equiv='refresh' content='30' ></head>"; // page refresh time
echo "<body>";
echo "<h3>".$pageTitle."</h3>";

echo "<table id='users'>";
echo "<tr>";
echo "<th>#</th>";
echo "<th>Callsign</th>";
echo "<th>Serial</th>";
echo "<th>Last TX</th>";
echo "<th>Port</th>";
echo "<th>Location</th>";
echo "<th>Where am I</th>";
echo "<th>Who am I</th>";
echo "</tr>";

for ($x=0;$x<=$i-1;$x++) {
  echo "<tr>";
  
  // formatting date
  $date = date_create($myLog[$x]['TX']);
  $myTXDate = date_format($date,'H:i:s d-m-Y'); // for italian style
  
  // formatting Google map position
  if (strlen($myLog[$x]['Location']) >0) {
    $myLocation = explode("/", $myLog[$x]['Location']);
    $lat = "N".preg_replace("/[^0-9\s+]/", '', $myLocation[0]);
    $lng = "E".preg_replace("/[^0-9\s+]/", '', $myLocation[1]); 
    $urlGoogleMap = "<a href='https://www.google.com/maps/place/".$lat.",".$lng."'>Map</a>";
  } else {
	$urlGoogleMap = "";  
  }
  
  // working with the serial number
  if ($myLog[$x]['Serial'] == $nodeSerial) {
    $mySerial = "from GATEWAY/INTERLINK";
  } else {
    $mySerial = $myLog[$x]['Serial'];
  }
  
  // get the call w/out any other sign and prepare it for qrz services
  $myCall = preg_split("~[^a-z0-9]~i",$myLog[$x]['Callsign']);
  $urlQrz = "<a href='https://www.qrz.com/db/".$myCall[0]."'>Qrz</a>";
  
  echo "<td>".($x+1)."</td><td>".$myLog[$x]['Callsign']."</td><td>".$mySerial."</td><td>".$myTXDate."</td><td>".$myLog[$x]['Port']."</td><td>".$myLog[$x]['Location']."</td><td>".$urlGoogleMap."</td><td>".$urlQrz."</td>";
  echo "</tr>";
  // set to show ONLY last 30 TXs
  if ($x == 29) {
    break;
  }
}
echo "</table></body></html>";

?>
